import VueType, { VNode } from 'vue';
import { DirectiveBinding } from 'vue/types/options';
export interface ObserverOptionsType {
    delay?: number;
    threshold?: number[];
    trackVisibility?: boolean;
}
export declare type FuncHandler = (el?: Element) => void;
export declare type ObjectHandler = {
    enter?: FuncHandler;
    leave?: FuncHandler;
};
export declare type ExposureHandler = FuncHandler | ObjectHandler;
export interface ElToMetaType {
    active: {
        enter: boolean;
        leave: boolean;
    };
    handler: ExposureHandler;
    context: VueType | undefined;
    threshold: number;
}
export interface DirectiveHandlerType {
    (el: Element, binding: DirectiveBinding, vnode: VNode): void;
}
export interface InstallHandlerType {
    (_Vue: typeof VueType, options?: {
        threshold?: number;
    }): void;
}
export declare const useResetExposure: (el: Element) => void;
declare module 'vue/types/vue' {
    interface Vue {
        $resetExposure: typeof useResetExposure;
    }
}
interface ObserveOption {
    context: VueType;
    threshold?: number;
}
export declare const createExposureObserver: (option: ObserveOption) => (el: Element, handler: ExposureHandler) => void;
declare const Exposure: {
    install: InstallHandlerType;
};
export default Exposure;
